% written by Venugopal Rajagopal for Longin Jan Latecki, latecki@temple.edu, Oct 31, 2003
%example usage: driverfile(8,8,3,'1.tif');

function [] = driverfile(w,h,dim,filename);

close all;

[x, imagerows, imagecols] = cut(filename, w, h);

num = size(x,2);
 
[pc,latent,explained] = pcacov(cov(x'));
 
m = mean(x')';

for i = 1:num
     c = pc(:,[1:dim])'*(x(:,i) - m); 
     pcavectors(i,:)=c';
     z(:,i) = pc(:,[1:dim])*c + m;  % Reconstruct from projection
end


lumrecon = col2im(z,[h w],[imagerows imagecols],'distinct'); % Reconstruct the image from z
fprintf(1,'Reconstruction done\n');
fprintf(1,'Size of the final reconstructed image %d %d\n',size(lumrecon));
figure
imshow(lumrecon)

figure; plot3(pcavectors(:,1), pcavectors(:,2), pcavectors(:,3),'.');